/*! \file
 * X-Forge Core <br>
 * Copyright 2000-2003 Fathammer Ltd
 *
 * \brief Bluetooth XForge server search.
 *
 * $Id: XFcBtServerSearch.h,v 1.4 2003/04/25 08:14:38 jetro Exp $
 * $Date: 2003/04/25 08:14:38 $
 * $Revision: 1.4 $
 */

#ifndef XFCBTSERVERSEARCH_H_INCLUDED
#define XFCBTSERVERSEARCH_H_INCLUDED

#include <xfcore/XFcLinkedList.h>

class XFcAdvertiser;
class XFcDeviceDiscovery;


class XFcBtServerSearch
{
private:

    //! Holds device discovery callback pointer.
    XFcDeviceDiscovery *mDeviceDiscovery;

    //! Holds server search pointer.
    void *mService;
    
protected:

    //! Protected constructor.
    XFcBtServerSearch();

    //! Initializes XFcBtServerSearch.
    INT init();
    
public:

    //! Virtual destructor.
    virtual ~XFcBtServerSearch();

    //! Static constructor.
    /*! Constructs a server search object.
     */
    XFCIMPORT static XFcBtServerSearch *create();

    //! Inquiry servers.
    XFCIMPORT INT inquiry(XFcDeviceDiscovery *aDeviceDiscovery);

    //! Cancel server inquiry.
    XFCIMPORT void cancelInquiry();

    //! Callback for inquiry result.
    XFCIMPORT void inquiryResult(XFcLinkedList<XFcAdvertiser *> &aAdvertiser);
};


#endif // !XFCBTSERVERSEARCH_H_INCLUDED
