/*
 * \file
 * X-Forge Engine <br>
 * Copyright 2000-2003 Fathammer Ltd
 *
 * \brief Remote debugger service.
 *
 * $Id: XFuRemoteDebugService.h,v 1.4 2003/04/14 08:09:56 peppe Exp $
 * $Date: 2003/04/14 08:09:56 $
 * $Revision: 1.4 $
 */

#ifndef XFUREMOTEDEBUGSERVICE_H_INCLUDED
#define XFUREMOTEDEBUGSERVICE_H_INCLUDED

class XFuRemoteDebugService
{

protected:

    /*! Constructor.
     */
    XFuRemoteDebugService() {}

public:

    /*! Receives data.
     * \param aBuffer holds pointer to received buffer.
     * \param aSize is size of the received buffer.
     * \param aError holds error value if any.
     */
    virtual void remoteDebugReceive(const CHAR8 *aBuffer, INT32 aSize, INT32 aError) {}

    /*! Receives data.
     * \param aBuffer holds pointer to null terminate received buffer string, minus the header.
     * \param aError holds error value if any.
     */
    virtual void remoteDebugReceive(const CHAR8 *aBuffer, INT32 aError) {}

    /*! Destructor
     */
    virtual ~XFuRemoteDebugService() {}

};

#endif
